function output = cart2sph (input, dir)
%Convert between cartesian coordinates and spherical
%input = array of cartesian coordinates [x,y,z]
%dir = non-zero integer, indicating direction of conversion
%   position = cartesian to spherical, negative is opposite
%Can be 2d array with each row as coordinate triplet

if dir == 0; error("CART2SPH:DIRZERO","Direction input must be non-zero"); end

if dir > 0
    output  = [sqrt(input(:,1).^2+input(:,2).^2+input(:,3).^2),...
             atan2(input(:,3), sqrt(input(:,1).^2 + input(:,2).^2)),...
             atan2(input(:,2), input(:,1))];
else
    output = [input(:,1) .* cos(input(:,2)) .* cos(input(:,3)),...
         input(:,1) .* cos(input(:,2)) .* sin(input(:,3)),...
         input(:,1) .* sin(input(:,2))];
end

end